alpha = 50
life = 1
width = 1

colors = {

'Red':     (255, 0, 0),
'Green':   (0, 255, 0),
'Blue':    (0, 0, 255),
'Gray':    (211, 211, 211),

}


message_prefix = " \x04[ \x06Tracers \x04] \x01 "



#####################################################



import time
import random

import ezsp as ez

from players.helpers import index_from_playerinfo
from commands.say import SayCommand
from events import Event
from menus import PagedMenu
from menus import Option
from mathlib import Vector



tracers = {}
nospam = {}


@Event
def game_start(game_event):
    nospam.clear()

@Event
def bullet_impact(game_event):
    userid = game_event.get_int('userid')
    index = ez.getindex(userid)

    if index not in tracers:
        return

    if tracers[index] == 'random':
        red = random.randint(0, 255)
        green = random.randint(0, 255)
        blue = random.randint(0, 255)
    else:
        red, green, blue = tracers[index]

    crouched = ez.iscrouched(index)
    x1, y1, z1 = ez.getplayerlocation(index)
    z1 += 44 if crouched else 64
    x2 = game_event.get_float('x')
    y2 = game_event.get_float('y')
    z2 = game_event.get_float('z')
    loc1 = Vector(x1, y1, z1)
    loc2 = Vector(x2, y2, z2)

    ez.drawline(loc1, loc2, life=life, width=width, red=red, green=green, blue=blue, alpha=alpha)

@SayCommand(['!tracer', '!tracers'])
def tracerCommand(playerinfo, teamonly, command):
    now = time.time()
    index = index_from_playerinfo(playerinfo)
    if now - nospam.get(index, 0) >= 1:
        m = PagedMenu(
            title='Tracers',
            select_callback=tracers_callback
        )

        m.append(Option('No Tracer', 1))
        m.append(Option('Random', 'random'))
        for color in colors:
            m.append(Option(color, colors[color]))

        m.send(index)
    else:
        ez.tell(index, message_prefix + "Please do not spam.")

def tracers_callback(menu, index, option):
    if option.value == 1:
        if index in tracers:
            del tracers[index]
        return ez.tell(index, message_prefix + "You have disabled your tracer.")
    tracers[index] = option.value

    if option.value == 'random':
        choice = 'Random'

    for color in colors:
        if colors[color] == option.value:
            choice = color

    ez.tell(index, message_prefix + "You have chosen the tracer \x0A{0}.".format(choice))

